Compare commits

..

1 Commits

Author SHA1 Message Date
Daan De Meyer 6a7ac1d46d
Merge 99fd958d52 into 099b16c3e7 2024-09-17 23:09:51 +02:00
15 changed files with 91 additions and 137 deletions

View File

@ -593,6 +593,8 @@ node /org/freedesktop/systemd1 {
<!--method GetJobBefore is not documented!--> <!--method GetJobBefore is not documented!-->
<!--method SetShowStatus is not documented!-->
<!--method ListUnitsFiltered is not documented!--> <!--method ListUnitsFiltered is not documented!-->
<!--method ListUnitsByPatterns is not documented!--> <!--method ListUnitsByPatterns is not documented!-->
@ -671,6 +673,8 @@ node /org/freedesktop/systemd1 {
<!--property ConfirmSpawn is not documented!--> <!--property ConfirmSpawn is not documented!-->
<!--property ShowStatus is not documented!-->
<!--property DefaultStandardOutput is not documented!--> <!--property DefaultStandardOutput is not documented!-->
<!--property DefaultStandardError is not documented!--> <!--property DefaultStandardError is not documented!-->
@ -1358,24 +1362,6 @@ node /org/freedesktop/systemd1 {
<para><function>ResetFailedUnit()</function> resets the "failed" state of a specific unit.</para> <para><function>ResetFailedUnit()</function> resets the "failed" state of a specific unit.</para>
<para><function>SetShowStatus()</function> configures the display of status messages during bootup and
shutdown. The <varname>mode</varname> parameter can be set to any value that's valid for the
<varname>systemd.show_status</varname> kernel parameter. For more information about
<varname>systemd.show_status</varname>, see
<citerefentry project="man-pages"><refentrytitle>systemd</refentrytitle><manvolnum>1</manvolnum></citerefentry>.
The <varname>mode</varname> parameter can also be set to an empty string. When <varname>mode</varname>
is set to an empty string, <function>SetShowStatus()</function> will reset
<varname>ShowStatus</varname> back to its original value. You can use
<function>SetShowStatus()</function> create a service that does something like this:
<orderedlist>
<listitem><para>Send a D-Bus message that will turn off status messages.</para></listitem>
<listitem><para>Block until a reply to that message is received.</para></listitem>
<listitem><para>Print multiples lines without being interrupted by status messages.</para></listitem>
<listitem><para>Send a D-Bus message that will reset <varname>ShowStatus</varname> back to its
original value.</para></listitem>
</orderedlist>
</para>
<para><function>ResetFailed()</function> resets the "failed" state of all units.</para> <para><function>ResetFailed()</function> resets the "failed" state of all units.</para>
<para><function>ListUnits()</function> returns an array of all currently loaded units. Note that <para><function>ListUnits()</function> returns an array of all currently loaded units. Note that
@ -1802,12 +1788,6 @@ node /org/freedesktop/systemd1 {
<para><varname>Environment</varname> encodes the environment block passed to all executed services. It <para><varname>Environment</varname> encodes the environment block passed to all executed services. It
may be altered with bus calls such as <function>SetEnvironment()</function> (see above).</para> may be altered with bus calls such as <function>SetEnvironment()</function> (see above).</para>
<para><varname>ShowStatus</varname> encodes systemd's current policy for displaying status messages
during bootup and shutdown. Its value can be any valid value for the
<varname>systemd.show_status</varname> kernel parameter (see
<citerefentry project="man-pages"><refentrytitle>systemd</refentrytitle><manvolnum>1</manvolnum></citerefentry>).
It may be altered using <function>SetShowStatus()</function> (see above).</para>
<para><varname>UnitPath</varname> encodes the currently active unit file search path. It is an array of <para><varname>UnitPath</varname> encodes the currently active unit file search path. It is an array of
file system paths encoded as strings.</para> file system paths encoded as strings.</para>

View File

@ -483,18 +483,18 @@
<term><varname>ExcludeFiles=</varname></term> <term><varname>ExcludeFiles=</varname></term>
<term><varname>ExcludeFilesTarget=</varname></term> <term><varname>ExcludeFilesTarget=</varname></term>
<listitem><para>Takes one or more absolute paths, separated by whitespace, each referring to a <listitem><para>Takes an absolute file system path referring to a source file or directory on the
source file or directory on the host. This setting may be used to exclude files or directories from host. This setting may be used to exclude files or directories from the host from being copied into
the host from being copied into the file system when <varname>CopyFiles=</varname> is used. This the file system when <varname>CopyFiles=</varname> is used. This option may be used multiple times to
option may be used multiple times to exclude multiple files or directories from host from being exclude multiple files or directories from host from being copied into the newly formatted file
copied into the newly formatted file system.</para> system.</para>
<para>If the path is a directory and ends with <literal>/</literal>, only the directory's <para>If the path is a directory and ends with <literal>/</literal>, only the directory's
contents are excluded but not the directory itself. If the path is a directory and does not end with contents are excluded but not the directory itself. If the path is a directory and does not end with
<literal>/</literal>, both the directory and its contents are excluded.</para> <literal>/</literal>, both the directory and its contents are excluded.</para>
<para><varname>ExcludeFilesTarget=</varname> is like <varname>ExcludeFiles=</varname> except that <para><varname>ExcludeFilesTarget=</varname> is like <varname>ExcludeFiles=</varname> except that
instead of excluding the path on the host from being copied into the partition, it exclude any files instead of excluding the path on the host from being copied into the partition, we exclude any files
and directories from being copied into the given path in the partition.</para> and directories from being copied into the given path in the partition.</para>
<para>When <para>When

View File

@ -3001,12 +3001,7 @@ SystemCallErrorNumber=EPERM</programlisting>
<para><option>tty</option> connects standard output to a tty (as configured via <varname>TTYPath=</varname>, <para><option>tty</option> connects standard output to a tty (as configured via <varname>TTYPath=</varname>,
see below). If the TTY is used for output only, the executed process will not become the controlling process of see below). If the TTY is used for output only, the executed process will not become the controlling process of
the terminal, and will not fail or wait for other processes to release the terminal. Note: if a unit the terminal, and will not fail or wait for other processes to release the terminal.</para>
tries to print multiple lines to a TTY during bootup or shutdown, then there's a chance that those
lines will be broken up by status messages. <function>SetShowStatus()</function> can be used to
prevent this problem. See
<citerefentry project="man-pages"><refentrytitle>org.freedesktop.systemd1</refentrytitle><manvolnum>5</manvolnum></citerefentry>
for details.</para>
<para><option>journal</option> connects standard output with the journal, which is accessible via <para><option>journal</option> connects standard output with the journal, which is accessible via
<citerefentry><refentrytitle>journalctl</refentrytitle><manvolnum>1</manvolnum></citerefentry>. Note <citerefentry><refentrytitle>journalctl</refentrytitle><manvolnum>1</manvolnum></citerefentry>. Note

View File

@ -568,11 +568,7 @@
<listitem><para>Enables display of status messages on the <listitem><para>Enables display of status messages on the
console, as controlled via console, as controlled via
<varname>systemd.show_status=1</varname> on the kernel command <varname>systemd.show_status=1</varname> on the kernel command
line.</para> line.</para></listitem>
<para>You may want to use <function>SetShowStatus()</function> instead of
<constant>SIGRTMIN+20</constant> in order to prevent race conditions. See
<citerefentry project="man-pages"><refentrytitle>org.freedesktop.systemd1</refentrytitle><manvolnum>5</manvolnum></citerefentry>.
</para></listitem>
</varlistentry> </varlistentry>
<varlistentry> <varlistentry>
@ -583,11 +579,7 @@
controlled via controlled via
<varname>systemd.show_status=0</varname> <varname>systemd.show_status=0</varname>
on the kernel command on the kernel command
line.</para> line.</para></listitem>
<para>You may want to use <function>SetShowStatus()</function> instead of
<constant>SIGRTMIN+21</constant> in order to prevent race conditions. See
<citerefentry project="man-pages"><refentrytitle>org.freedesktop.systemd1</refentrytitle><manvolnum>5</manvolnum></citerefentry>.
</para></listitem>
</varlistentry> </varlistentry>
<varlistentry> <varlistentry>

View File

@ -4169,7 +4169,7 @@ static void service_sigchld_event(Unit *u, pid_t pid, int code, int status) {
* detect when the cgroup becomes empty. Note that the control process is always * detect when the cgroup becomes empty. Note that the control process is always
* our child so it's pointless to watch all other processes. */ * our child so it's pointless to watch all other processes. */
if (!control_pid_good(s)) if (!control_pid_good(s))
if (!s->main_pid_known || s->main_pid_alien || unit_cgroup_delegate(u)) if (!s->main_pid_known || s->main_pid_alien)
(void) unit_enqueue_rewatch_pids(u); (void) unit_enqueue_rewatch_pids(u);
} }

View File

@ -404,16 +404,15 @@ static int context_set_path_strv(Context *c, char* const* strv, const char *sour
static int context_set_plugins(Context *c, const char *s, const char *source) { static int context_set_plugins(Context *c, const char *s, const char *source) {
_cleanup_strv_free_ char **v = NULL; _cleanup_strv_free_ char **v = NULL;
int r;
assert(c); assert(c);
if (c->plugins || !s) if (c->plugins || !s)
return 0; return 0;
r = strv_split_full(&v, s, NULL, EXTRACT_UNQUOTE); v = strv_split(s, NULL);
if (r < 0) if (!v)
return log_error_errno(r, "Failed to parse plugin paths from %s: %m", source); return log_oom();
return context_set_path_strv(c, v, source, "plugins", &c->plugins); return context_set_path_strv(c, v, source, "plugins", &c->plugins);
} }

View File

@ -46,13 +46,7 @@ echo 'DTBDTBDTBDTB' >"$D/sources/subdir/whatever.dtb"
export KERNEL_INSTALL_CONF_ROOT="$D/sources" export KERNEL_INSTALL_CONF_ROOT="$D/sources"
# We "install" multiple plugins, but control which ones will be active via install.conf. # We "install" multiple plugins, but control which ones will be active via install.conf.
KERNEL_INSTALL_PLUGINS="'${loaderentry_install}' '${uki_copy_install}'" export KERNEL_INSTALL_PLUGINS="${ukify_install} ${loaderentry_install} ${uki_copy_install}"
if [[ -n "$ukify_install" ]]; then
# shellcheck disable=SC2089
KERNEL_INSTALL_PLUGINS="'${ukify_install}' $KERNEL_INSTALL_PLUGINS"
fi
# shellcheck disable=SC2090
export KERNEL_INSTALL_PLUGINS
export BOOT_ROOT="$D/boot" export BOOT_ROOT="$D/boot"
export BOOT_MNT="$D/boot" export BOOT_MNT="$D/boot"
export MACHINE_ID='3e0484f3634a418b8e6a39e8828b03e3' export MACHINE_ID='3e0484f3634a418b8e6a39e8828b03e3'

View File

@ -1742,9 +1742,8 @@ static int config_parse_exclude_files(
const char *rvalue, const char *rvalue,
void *data, void *data,
void *userdata) { void *userdata) {
_cleanup_free_ char *resolved = NULL;
char ***exclude_files = ASSERT_PTR(data); char ***exclude_files = ASSERT_PTR(data);
const char *p = ASSERT_PTR(rvalue);
int r; int r;
if (isempty(rvalue)) { if (isempty(rvalue)) {
@ -1752,23 +1751,10 @@ static int config_parse_exclude_files(
return 0; return 0;
} }
for (;;) { r = specifier_printf(rvalue, PATH_MAX-1, system_and_tmp_specifier_table, arg_root, NULL, &resolved);
_cleanup_free_ char *word = NULL, *resolved = NULL;
r = extract_first_word(&p, &word, NULL, EXTRACT_UNQUOTE);
if (r == -ENOMEM)
return log_oom();
if (r < 0) {
log_syntax(unit, LOG_WARNING, filename, line, r, "Invalid syntax, ignoring: %s", p);
return 0;
}
if (r == 0)
return 0;
r = specifier_printf(word, PATH_MAX-1, system_and_tmp_specifier_table, arg_root, NULL, &resolved);
if (r < 0) { if (r < 0) {
log_syntax(unit, LOG_WARNING, filename, line, r, log_syntax(unit, LOG_WARNING, filename, line, r,
"Failed to expand specifiers in %s path, ignoring: %s", lvalue, word); "Failed to expand specifiers in ExcludeFiles= path, ignoring: %s", rvalue);
return 0; return 0;
} }
@ -1778,7 +1764,6 @@ static int config_parse_exclude_files(
if (strv_consume(exclude_files, TAKE_PTR(resolved)) < 0) if (strv_consume(exclude_files, TAKE_PTR(resolved)) < 0)
return log_oom(); return log_oom();
}
return 0; return 0;
} }

View File

@ -197,7 +197,7 @@ _unused_ static void test_compress_stream(const char *compression,
ASSERT_OK(compress(src, dst, -1, &uncompressed_size)); ASSERT_OK(compress(src, dst, -1, &uncompressed_size));
if (cat) { if (cat) {
assert_se(asprintf(&cmd, "%s %s | diff '%s' -", cat, pattern, srcfile) > 0); assert_se(asprintf(&cmd, "%s %s | diff %s -", cat, pattern, srcfile) > 0);
assert_se(system(cmd) == 0); assert_se(system(cmd) == 0);
} }
@ -212,7 +212,7 @@ _unused_ static void test_compress_stream(const char *compression,
r = decompress(dst, dst2, st.st_size); r = decompress(dst, dst2, st.st_size);
assert_se(r == 0); assert_se(r == 0);
assert_se(asprintf(&cmd2, "diff '%s' %s", srcfile, pattern2) > 0); assert_se(asprintf(&cmd2, "diff %s %s", srcfile, pattern2) > 0);
assert_se(system(cmd2) == 0); assert_se(system(cmd2) == 0);
log_debug("/* test faulty decompression */"); log_debug("/* test faulty decompression */");

View File

@ -52,8 +52,7 @@ static void test_event_spawn_self(const char *self, const char *arg, bool with_p
log_debug("/* %s(%s, %s) */", __func__, arg, yes_no(with_pidfd)); log_debug("/* %s(%s, %s) */", __func__, arg, yes_no(with_pidfd));
/* 'self' may contain spaces, hence needs to be quoted. */ assert_se(cmd = strjoin(self, " ", arg));
assert_se(cmd = strjoin("'", self, "' ", arg));
test_event_spawn_core(with_pidfd, cmd, result_buf, BUF_SIZE); test_event_spawn_core(with_pidfd, cmd, result_buf, BUF_SIZE);

View File

@ -0,0 +1,10 @@
#!/usr/bin/env bash
# SPDX-License-Identifier: LGPL-2.1-or-later
set -e
TEST_DESCRIPTION="Test Multi-Profile UKI Boots"
# shellcheck source=test/test-functions
. "${TEST_BASE_DIR:?}/test-functions"
do_test "$@"

View File

@ -4,32 +4,32 @@ set -e
ANALYZE="${1:-systemd-analyze}" ANALYZE="${1:-systemd-analyze}"
"$ANALYZE" compare-versions 1 lt 2 $ANALYZE compare-versions 1 lt 2
"$ANALYZE" compare-versions 1 '<' 2 $ANALYZE compare-versions 1 '<' 2
"$ANALYZE" compare-versions 1 le 2 $ANALYZE compare-versions 1 le 2
"$ANALYZE" compare-versions 1 '<=' 2 $ANALYZE compare-versions 1 '<=' 2
"$ANALYZE" compare-versions 1 ne 2 $ANALYZE compare-versions 1 ne 2
"$ANALYZE" compare-versions 1 '!=' 2 $ANALYZE compare-versions 1 '!=' 2
( ! "$ANALYZE" compare-versions 1 ge 2 ) ( ! $ANALYZE compare-versions 1 ge 2 )
( ! "$ANALYZE" compare-versions 1 '>=' 2 ) ( ! $ANALYZE compare-versions 1 '>=' 2 )
( ! "$ANALYZE" compare-versions 1 eq 2 ) ( ! $ANALYZE compare-versions 1 eq 2 )
( ! "$ANALYZE" compare-versions 1 '==' 2 ) ( ! $ANALYZE compare-versions 1 '==' 2 )
( ! "$ANALYZE" compare-versions 1 gt 2 ) ( ! $ANALYZE compare-versions 1 gt 2 )
( ! "$ANALYZE" compare-versions 1 '>' 2 ) ( ! $ANALYZE compare-versions 1 '>' 2 )
test "$("$ANALYZE" compare-versions 1 2)" = '1 < 2' test "$($ANALYZE compare-versions 1 2)" = '1 < 2'
test "$("$ANALYZE" compare-versions 2 2)" = '2 == 2' test "$($ANALYZE compare-versions 2 2)" = '2 == 2'
test "$("$ANALYZE" compare-versions 2 1)" = '2 > 1' test "$($ANALYZE compare-versions 2 1)" = '2 > 1'
test "$("$ANALYZE" compare-versions '' '')" = "'' == ''" test "$($ANALYZE compare-versions '' '')" = "'' == ''"
set +e set +e
"$ANALYZE" compare-versions 1 2; ret1=$? $ANALYZE compare-versions 1 2; ret1=$?
"$ANALYZE" compare-versions 2 2; ret2=$? $ANALYZE compare-versions 2 2; ret2=$?
"$ANALYZE" compare-versions 2 1; ret3=$? $ANALYZE compare-versions 2 1; ret3=$?
set -e set -e
test "$ret1" == 12 test $ret1 == 12
test "$ret2" == 0 test $ret2 == 0
test "$ret3" == 11 test $ret3 == 11

View File

@ -44,9 +44,9 @@ test_one() (
fi fi
if [[ "${input##*/}" =~ \.fstab\.input ]]; then if [[ "${input##*/}" =~ \.fstab\.input ]]; then
SYSTEMD_LOG_LEVEL=debug SYSTEMD_IN_INITRD="$initrd" SYSTEMD_SYSFS_CHECK=no SYSTEMD_PROC_CMDLINE="fstab=yes root=fstab" SYSTEMD_FSTAB="$input" SYSTEMD_SYSROOT_FSTAB="/dev/null" "$generator" "$out" "$out" "$out" SYSTEMD_LOG_LEVEL=debug SYSTEMD_IN_INITRD="$initrd" SYSTEMD_SYSFS_CHECK=no SYSTEMD_PROC_CMDLINE="fstab=yes root=fstab" SYSTEMD_FSTAB="$input" SYSTEMD_SYSROOT_FSTAB="/dev/null" $generator "$out" "$out" "$out"
else else
SYSTEMD_LOG_LEVEL=debug SYSTEMD_IN_INITRD="$initrd" SYSTEMD_SYSFS_CHECK=no SYSTEMD_PROC_CMDLINE="fstab=no $(cat "$input")" "$generator" "$out" "$out" "$out" SYSTEMD_LOG_LEVEL=debug SYSTEMD_IN_INITRD="$initrd" SYSTEMD_SYSFS_CHECK=no SYSTEMD_PROC_CMDLINE="fstab=no $(cat "$input")" $generator "$out" "$out" "$out"
fi fi
# The option x-systemd.growfs creates symlink to system's systemd-growfs@.service in .mount.wants directory. # The option x-systemd.growfs creates symlink to system's systemd-growfs@.service in .mount.wants directory.

View File

@ -53,7 +53,7 @@ for f in $(find "$SOURCE"/test-*.input | sort -V); do
echo "*** Running $f" echo "*** Running $f"
prepare_testdir "${f%.input}" prepare_testdir "${f%.input}"
cp "$f" "$TESTDIR/usr/lib/sysusers.d/test.conf" cp "$f" "$TESTDIR/usr/lib/sysusers.d/test.conf"
"$SYSUSERS" --root="$TESTDIR" $SYSUSERS --root="$TESTDIR"
compare "${f%.*}" "" compare "${f%.*}" ""
done done
@ -62,7 +62,7 @@ for f in $(find "$SOURCE"/test-*.input | sort -V); do
echo "*** Running $f on stdin" echo "*** Running $f on stdin"
prepare_testdir "${f%.input}" prepare_testdir "${f%.input}"
touch "$TESTDIR/etc/sysusers.d/test.conf" touch "$TESTDIR/etc/sysusers.d/test.conf"
"$SYSUSERS" --root="$TESTDIR" - <"$f" $SYSUSERS --root="$TESTDIR" - <"$f"
compare "${f%.*}" "on stdin" compare "${f%.*}" "on stdin"
done done
@ -72,9 +72,9 @@ for f in $(find "$SOURCE"/test-*.input | sort -V); do
prepare_testdir "${f%.input}" prepare_testdir "${f%.input}"
touch "$TESTDIR/etc/sysusers.d/test.conf" touch "$TESTDIR/etc/sysusers.d/test.conf"
# this overrides test.conf which is masked on disk # this overrides test.conf which is masked on disk
"$SYSUSERS" --root="$TESTDIR" --replace=/etc/sysusers.d/test.conf - <"$f" $SYSUSERS --root="$TESTDIR" --replace=/etc/sysusers.d/test.conf - <"$f"
# this should be ignored # this should be ignored
"$SYSUSERS" --root="$TESTDIR" --replace=/usr/lib/sysusers.d/test.conf - <"$SOURCE/test-1.input" $SYSUSERS --root="$TESTDIR" --replace=/usr/lib/sysusers.d/test.conf - <"$SOURCE/test-1.input"
compare "${f%.*}" "on stdin with --replace" compare "${f%.*}" "on stdin with --replace"
done done
@ -84,7 +84,7 @@ echo "*** Testing --inline"
prepare_testdir "$SOURCE/inline" prepare_testdir "$SOURCE/inline"
# copy a random file to make sure it is ignored # copy a random file to make sure it is ignored
cp "$f" "$TESTDIR/etc/sysusers.d/confuse.conf" cp "$f" "$TESTDIR/etc/sysusers.d/confuse.conf"
"$SYSUSERS" --root="$TESTDIR" --inline \ $SYSUSERS --root="$TESTDIR" --inline \
"u u1 222 - - /bin/zsh" \ "u u1 222 - - /bin/zsh" \
"g g1 111" "g g1 111"
@ -95,7 +95,7 @@ echo "*** Testing --inline with --replace"
prepare_testdir "$SOURCE/inline" prepare_testdir "$SOURCE/inline"
# copy a random file to make sure it is ignored # copy a random file to make sure it is ignored
cp "$f" "$TESTDIR/etc/sysusers.d/confuse.conf" cp "$f" "$TESTDIR/etc/sysusers.d/confuse.conf"
"$SYSUSERS" --root="$TESTDIR" \ $SYSUSERS --root="$TESTDIR" \
--inline \ --inline \
--replace=/etc/sysusers.d/confuse.conf \ --replace=/etc/sysusers.d/confuse.conf \
"u u1 222 - - /bin/zsh" \ "u u1 222 - - /bin/zsh" \
@ -105,7 +105,7 @@ compare "$SOURCE/inline" "(--inline --replace=…)"
echo "*** Testing --inline with no /etc" echo "*** Testing --inline with no /etc"
rm -rf "${TESTDIR:?}/etc" rm -rf "${TESTDIR:?}/etc"
"$SYSUSERS" --root="$TESTDIR" --inline \ $SYSUSERS --root="$TESTDIR" --inline \
"u u1 222 - - /bin/zsh" \ "u u1 222 - - /bin/zsh" \
"g g1 111" "g g1 111"
@ -136,7 +136,7 @@ for f in $(find "$SOURCE"/test-*.input | sort -V); do
echo "*** Running $f (with login.defs)" echo "*** Running $f (with login.defs)"
prepare_testdir "${f%.input}" prepare_testdir "${f%.input}"
cp "$f" "$TESTDIR/usr/lib/sysusers.d/test.conf" cp "$f" "$TESTDIR/usr/lib/sysusers.d/test.conf"
"$SYSUSERS" --root="$TESTDIR" $SYSUSERS --root="$TESTDIR"
# shellcheck disable=SC2050 # shellcheck disable=SC2050
[ @ENABLE_COMPAT_MUTABLE_UID_BOUNDARIES@ = 1 ] && bound=555 || bound=$system_guid_max [ @ENABLE_COMPAT_MUTABLE_UID_BOUNDARIES@ = 1 ] && bound=555 || bound=$system_guid_max
@ -152,7 +152,7 @@ for f in $(find "$SOURCE"/test-*.input | sort -V); do
echo "*** Running $f (with login.defs symlinked)" echo "*** Running $f (with login.defs symlinked)"
prepare_testdir "${f%.input}" prepare_testdir "${f%.input}"
cp "$f" "$TESTDIR/usr/lib/sysusers.d/test.conf" cp "$f" "$TESTDIR/usr/lib/sysusers.d/test.conf"
"$SYSUSERS" --root="$TESTDIR" $SYSUSERS --root="$TESTDIR"
# shellcheck disable=SC2050 # shellcheck disable=SC2050
[ @ENABLE_COMPAT_MUTABLE_UID_BOUNDARIES@ = 1 ] && bound=555 || bound=$system_guid_max [ @ENABLE_COMPAT_MUTABLE_UID_BOUNDARIES@ = 1 ] && bound=555 || bound=$system_guid_max
@ -166,7 +166,7 @@ for f in $(find "$SOURCE"/unhappy-*.input | sort -V); do
echo "*** Running test $f" echo "*** Running test $f"
prepare_testdir "${f%.input}" prepare_testdir "${f%.input}"
cp "$f" "$TESTDIR/usr/lib/sysusers.d/test.conf" cp "$f" "$TESTDIR/usr/lib/sysusers.d/test.conf"
SYSTEMD_LOG_LEVEL=info "$SYSUSERS" --root="$TESTDIR" 2>&1 | tail -n1 | sed -r 's/^[^:]+:[^:]+://' >"$TESTDIR/err" SYSTEMD_LOG_LEVEL=info $SYSUSERS --root="$TESTDIR" 2>&1 | tail -n1 | sed -r 's/^[^:]+:[^:]+://' >"$TESTDIR/err"
if ! diff -u "$TESTDIR/err" "${f%.*}.expected-err"; then if ! diff -u "$TESTDIR/err" "${f%.*}.expected-err"; then
echo >&2 "**** Unexpected error output for $f" echo >&2 "**** Unexpected error output for $f"
cat >&2 "$TESTDIR/err" cat >&2 "$TESTDIR/err"

View File

@ -17,9 +17,9 @@ if test -f /run/systemd/stub/profile; then
fi fi
echo "CURRENT MEASUREMENT:" echo "CURRENT MEASUREMENT:"
/usr/lib/systemd/systemd-measure --current /usr/lib/systemd/systemd-measure --current
if test -f /run/systemd/tpm2-pcr-signature.json; then if test -f /run/systemd/tpm2-pcr-signature.json ; then
echo "CURRENT SIGNATURE:" echo "CURRENT SIGNATURE:"
jq </run/systemd/tpm2-pcr-signature.json jq < /run/systemd/tpm2-pcr-signature.json
fi fi
echo "CURRENT EVENT LOG + PCRS:" echo "CURRENT EVENT LOG + PCRS:"
@ -45,7 +45,7 @@ TITLE="Profile Two"' --measure-base=/tmp/extended1.efi --cmdline="testprofile2=1
# Prepare a disk image, locked to the PCR measurements of the UKI we just generated # Prepare a disk image, locked to the PCR measurements of the UKI we just generated
truncate -s 32M /root/encrypted.raw truncate -s 32M /root/encrypted.raw
echo -n "geheim" >/root/encrypted.secret echo -n "geheim" > /root/encrypted.secret
cryptsetup luksFormat -q --pbkdf pbkdf2 --pbkdf-force-iterations 1000 --use-urandom /root/encrypted.raw --key-file=/root/encrypted.secret cryptsetup luksFormat -q --pbkdf pbkdf2 --pbkdf-force-iterations 1000 --use-urandom /root/encrypted.raw --key-file=/root/encrypted.secret
systemd-cryptenroll --tpm2-device=auto --tpm2-pcrs= --tpm2-public-key=/root/pcrsign.public.pem --unlock-key-file=/root/encrypted.secret /root/encrypted.raw systemd-cryptenroll --tpm2-device=auto --tpm2-pcrs= --tpm2-public-key=/root/pcrsign.public.pem --unlock-key-file=/root/encrypted.secret /root/encrypted.raw
rm -f /root/encrypted.secret rm -f /root/encrypted.secret
@ -62,12 +62,12 @@ else
if [ "$ID" = "profile0" ]; then if [ "$ID" = "profile0" ]; then
grep -v testprofile /proc/cmdline grep -v testprofile /proc/cmdline
echo "default $(basename "$CURRENT_UKI")@profile1" >"$(bootctl -p)/loader/loader.conf" echo "default $(basename "$CURRENT_UKI")@profile1" > "$(bootctl -p)/loader/loader.conf"
reboot reboot
exit 0 exit 0
elif [ "$ID" = "profile1" ]; then elif [ "$ID" = "profile1" ]; then
grep testprofile1=1 /proc/cmdline grep testprofile1=1 /proc/cmdline
echo "default $(basename "$CURRENT_UKI")@profile2" >"$(bootctl -p)/loader/loader.conf" echo "default $(basename "$CURRENT_UKI")@profile2" > "$(bootctl -p)/loader/loader.conf"
reboot reboot
exit 0 exit 0
elif [ "$ID" = "profile2" ]; then elif [ "$ID" = "profile2" ]; then